//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <time.h>
#pragma hdrstop

#include "CpkKeyWins.h"
#include "CpkKeyImptDlgs.h"
#include "Cyberpunk.h"
#include "PgpKeyWins.h"
#include "MixKeyWins.h"
#include "Mixmaster.h"
#include "HelpDlgs.h"
#include "PgpMail.h"
#include "PgpFiles.h"
#include "FileWin.h"
#include "FileMan.h"
#include "Global.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma link "explbtn"
#pragma link "MixKeyWins"
#pragma resource "*.dfm"
TCpkKeyWin *CpkKeyWin;
//---------------------------------------------------------------------------
//  TCpkKeyList
//---------------------------------------------------------------------------
__fastcall TCpkKeyList::TCpkKeyList()
{
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyList::TCpkKeyList(AnsiString FileName)
   : TMixKeyList()
{
   Sorted = true;
   Filename = FileName;
   cpkkeys = new TPGPbuffer(Filename);
   TStringList *keys = new TStringList();
   if (FileExists(Filename)) keys->LoadFromFile(Filename);

   TrimNullsBefore(keys);
   if (keys->Count && !CpkKeyDefinately(keys) && BeginPgpPubKeyBlockCount(keys)==1)
   {
      CpkBlockToKeysFull(keys);
    ::SaveToFileBak(keys,Filename,STATSBAKCOPIES);
   }
   LoadFromStrings(keys);
   delete keys;
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyList::TCpkKeyList(TStrings *AsciiBlock)
   : TMixKeyList()
{
   Sorted = true;
   cpkkeys = new TPGPbuffer(Filename);
   TStringList *keys = new TStringList();
   keys->Text = AsciiBlock->Text;
   while (keys->Count && keys->Strings[0].Trim().IsEmpty()) keys->Delete(0);

   //while (keys->Count && keys->Strings[0].Trim().IsEmpty()) keys->Delete(0);
   if (keys->Count && !CpkKeyDefinately(keys) && BeginPgpPubKeyBlockCount(keys)==1)
      CpkBlockToKeysFull(keys);
   LoadFromStrings(keys);
   delete keys;
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyList::~TCpkKeyList()
{
   delete cpkkeys;
}
//---------------------------------------------------------------------------
int __fastcall TCpkKeyList::AddAscii(TStrings *ascii)
{
   if (CpkKeyDefinately(ascii))
      return AddKey(CpkCrtDesc(CpkKeyDesc(ascii)),ascii);
   return -1;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TCpkKeyList::FullDesc(int atPos)
{
   if (atPos<0 || atPos>=Count) return "";
   TStrings *key = (TStrings*)(Objects[atPos]);
   if (!key || !key->Count) return "";
   return key->Strings[0];
}
//---------------------------------------------------------------------------
int  __fastcall TCpkKeyList::TimeStamp(AnsiString keydesc)
{
   //sm("TS:  "+GetToken(5,CrtDesc(keydesc)," "));
   return GetToken(5,CrtDesc(keydesc)," ").ToIntDef(-1);
}
//---------------------------------------------------------------------------
int  __fastcall TCpkKeyList::TimeStamp(int atPos)
{
   if (atPos<0 || atPos>=Count) return 0;
   return TimeStamp(Strings[atPos]);
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyList::LoadFromStrings(TStrings *Strings)
{
   Clear();
   AnsiString keydesc;
   TStringList *next=new TStringList();
   TStringList *key,*keys=new TStringList();
   keys->AddStrings(Strings);
   while (GetNextKey(keydesc,next,keys))
   {
//sm(next->Text); // uncomment to see each key field and ascii block
      if (KeyDescExists(keydesc) || keydesc.Pos(NoNameYet)==1) continue;
      key = new TStringList();     // 'nonameyet' excludes type1 remailers without
      key->AddStrings(next);       // description string available yet
      AddKey(keydesc,key);
   }
   delete keys;
   delete next;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TCpkKeyList::KeyDesc(int atPos)
{
   AnsiString desc;
   if (atPos<0 || atPos>=Count) return "";
   TStrings *key=dynamic_cast<TStrings*>(Objects[atPos]);
   if (key) desc = CpkKeyDesc(key);
   return desc;
}
//---------------------------------------------------------------------------
bool __fastcall TCpkKeyList::GetNextKey(AnsiString &keydesc, TStrings *key,
   TStrings *keys)
{
   return CpkGetNextKey(keydesc,key,keys);
}
//---------------------------------------------------------------------------
void __fastcall GetAllLongsShorts(AnsiString &rlisttxt, TStrings *longsshrts)
{
   longsshrts->Clear();
   AnsiString line,Shrt,Long;
   TStringList *rlist = new TStringList();
   rlist->LoadFromFile(clisttxt);
   for (int i=0; i<rlist->Count; i++)
   {
       line = rlist->Strings[i];
       if (line.Pos("$remailer{")==1)
       {
          Shrt = GetToken(1,line,"\"");
          Long = GetToken(1,line,"<");
          Long = GetToken(0,Long,">");
          longsshrts->Add(Long+"="+Shrt);
       }
   }
   delete rlist;
}
//---------------------------------------------------------------------------
AnsiString __fastcall padrightcpk(AnsiString string, int width)
{
   AnsiString str;
   return string+str.StringOfChar(32,width-string.Length());
}
//---------------------------------------------------------------------------
AnsiString __fastcall CrtDescLen(AnsiString keydesc, int slen, int length)
{
   if (keydesc.Pos("  ")>0) return keydesc;
   AnsiString shrt,addr,rest; slen += 2;
   shrt = GetToken(0,keydesc," ").LowerCase();
   addr = GetToken(1,keydesc," ").LowerCase();
   rest = GetToken(2,keydesc," ").UpperCase();             // 10 = 0x+idtext8
   if (rest.Length()>1) rest[2] = 'x';
   return padrightcpk(shrt,slen)+padrightcpk(addr,length-slen-10)+rest;
}
//---------------------------------------------------------------------------
AnsiString __fastcall DescLine(AnsiString &shrt, AnsiString &addr,
   AnsiString &rest, int slen, int length)
{
   return padrightcpk(shrt,slen+2)+padrightcpk(addr,length+2)+rest;
}
//---------------------------------------------------------------------------
/*void __fastcall TCpkKeyList::GenTreeView(TTreeView *TreeView,TStrings *type1,TList *keys)
{
   keys->Clear();
   SetRedraw(TreeView,0);
   TTreeNode *node,*cnode,*unode;
   TreeView->Items->Clear();
   TStringList *next = new TStringList();
   TPGPbuffer *cpkkey = new TPGPbuffer();
   TreeView->Items->BeginUpdate();
   int la,ls,Ls=0,La=0;
   for (int i=0; i<Count; i++)
   {
      la = GetParamSpc(1,Strings[i]).Length();
      ls = Strings[i].Pos(" ")-1;
      if (Ls<ls) Ls = ls;
      if (La<la) La = la;
   }

   TStringList *old = new TStringList();
   GetAppData(old,CpunkShorts);
   if (old->Count && old->Strings[0].Pos("=")==1)
   {
      while (old->Count && old->Strings[0].Pos("=")==1)
         old->Delete(0); // dump bad lines in CpunkShorts--temporary 07/16/01
      PutAppData(CpunkShorts,old);
   }
   TStringList *rems = new TStringList();
   rems->Sorted = true; rems->Duplicates = dupIgnore;
   GetAllLongsShorts(clisttxt,rems);
   rems->AddStrings(old);
   delete old;

   for (int i=0; i<Count; i++)
   {
      AnsiString addr,shrt,remdesc,id,idtext8,user,name,tstamp,keydesc,cpkdesc;
      TStrings *key=dynamic_cast<TStrings*>(Objects[i]);
      if (key && key->Count)
      {
         idtext8 = GetToken(2,key->Strings[0]," ");
         if (!cpkkeys->get(idtext8,cpkkey)) continue;

         long p;
         remdesc = key->Strings[0];
         bool revoked = cpkkey->revoked;
         bool expired = cpkkey->expired;
         addr = GetEAddress(cpkkey->firstuid);
         shrt = rems->Values[addr];
         if (shrt.IsEmpty()) continue;

         keydesc = DescLine(shrt,addr,"0x"+cpkkey->idtext8+"  "+cpkkey->algostr,Ls,La);
         //keydesc = shrt+"  "+addr+"  0x"+cpkkey->idtext8+"  "+cpkkey->algostr;

         if (revoked) keydesc += "  <---REVOKED "; else
         if (expired) keydesc += "  <---EXPIRED ";

         node=TreeView->Items->AddChildObject(TreeView->Selected,keydesc,NULL);
         node->ImageIndex = cpkkey->enabled ? 0:1;
         node->SelectedIndex = node->ImageIndex;
         if (newkeys->IndexOf(node->Text)>=0) SetTreeItemBold(node,true,TreeView);
         keys->Add(node);

         cnode=TreeView->Items->AddChild(node,"Name        "+shrt);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
         cnode=TreeView->Items->AddChild(node,"Address     "+addr);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
         AnsiString keyidline = "0x"+cpkkey->idtext8+(revoked?" <---REVOKED ":"");
         cnode=TreeView->Items->AddChild(node,"Key-Id      "+keyidline);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
         cnode=TreeView->Items->AddChild(node,"Key-Version "+s(cpkkey->version));
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
         cnode=TreeView->Items->AddChild(node,"Algorithm   "+cpkkey->algostr);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;

         p = 14; while ((id=GetToken(p++,remdesc," "))!="") user += " "+id;
         cnode=TreeView->Items->AddChild(node,"UserIds    "+cpkkey->firstuid);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;

         TStringList *uids = new TStringList();
         cpkkey->getuserids(uids);
         for (int i=0; i<uids->Count; i++)
         {
            unode=TreeView->Items->AddChild(cnode,uids->Strings[i]);
            unode->ImageIndex = -1; unode->SelectedIndex = -1;
         }
         delete uids;

         tstamp = cpkkey->timestr;
         if (revoked) tstamp += "  <---REVOKED";
         if (expired) tstamp += "  <---EXPIRED";
         cnode=TreeView->Items->AddChild(node,"TimeStamp   "+tstamp);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
         cnode=TreeView->Items->AddChild(node,"Validity    "+s(cpkkey->validity));//GetToken(6,remdesc," "));
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
         cnode=TreeView->Items->AddChild(node,"Bits        "+cpkkey->bitsstr);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;

      }
      cpkkey->clear();
      //i++;
   }
   TreeView->Items->EndUpdate();
   RECT r = { 0,0,4096,4096 };
   InvalidateRect(TreeView->Handle,&r,false);
   delete rems;
   delete cpkkey;
   delete next;
}*/
//---------------------------------------------------------------------------
void __fastcall TCpkKeyList::GenTreeView(TTreeView *TreeView,TStrings *type1,TList *keys)
{
   keys->Clear();
   SetRedraw(TreeView,0);
   TTreeNode *node,*cnode,*unode;
   TreeView->Items->Clear();
   TStringList *next=new TStringList();
   TPGPbuffer *cpkkey = new TPGPbuffer();
   TreeView->Items->BeginUpdate();
   int la,ls,Ls=0,La=0;
   for (int i=0; i<Count; i++)
   {
      la = Strings[i].Length();
      ls = Strings[i].Pos(" ")-1;
      if (Ls<ls) Ls = ls;
      if (La<la) La = la;
   }
   for (int i=0; i<Count; i++)
   {
      AnsiString remdesc,id,user,addr,name,tstamp,keydesc,cpkdesc;
      TStrings *key=dynamic_cast<TStrings*>(Objects[i]);
      if (key && key->Count)
      {
         long p,algo,lstamp;
         remdesc = key->Strings[0];
         bool revoked = GetToken(12,remdesc," ")=="1";
         bool expired = GetToken(13,remdesc," ")=="1";

         cpkdesc = CpkKeyDesc(key);
         keydesc = CrtDescLen(cpkdesc,Ls,La);

         if (revoked) keydesc += "  <---REVOKED "; else
         if (expired) keydesc += "  <---EXPIRED ";

         node=TreeView->Items->AddChildObject(TreeView->Selected,keydesc,NULL);
         node->ImageIndex = EnabledDesc(CrtDesc(cpkdesc),type1) ? 0:1;
         node->SelectedIndex = node->ImageIndex;
         if (newkeys->IndexOf(node->Text)>=0) SetTreeItemBold(node,true,TreeView);
         keys->Add(node);

         cnode=TreeView->Items->AddChild(node,"Name        "+GetToken(0,remdesc," "));
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
         cnode=TreeView->Items->AddChild(node,"Address     "+GetToken(1,remdesc," "));
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
         AnsiString keyidline = GetToken(2,remdesc," ");
         if (revoked) keyidline += " <---REVOKED ";
         cnode=TreeView->Items->AddChild(node,"Key-Id      "+keyidline);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
         cnode=TreeView->Items->AddChild(node,"Key-Version "+GetToken(8,remdesc," "));
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
         algo = GetToken(7,remdesc," ").ToIntDef(-1);
         cnode=TreeView->Items->AddChild(node,"Algorithm   "+(algo==1?s("RSA"):s((int)algo)));
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;

         p = 14; while ((id=GetToken(p++,remdesc," "))!="") user += " "+id;
         cnode=TreeView->Items->AddChild(node,"UserIds    "+GetToken(0,user,"|"));
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
         p = 0; while (!(id=GetToken(p++,user.TrimLeft(),"|")).IsEmpty())
         {
            unode=TreeView->Items->AddChild(cnode,id);
            unode->ImageIndex = -1; unode->SelectedIndex = -1;
         }

         lstamp = GetToken(5,remdesc," ").ToIntDef(0); tstamp = ctime(&lstamp);
         tstamp.SetLength(tstamp.Length()-1);
         if (expired) tstamp += "  <---EXPIRED ";
         cnode=TreeView->Items->AddChild(node,"TimeStamp   "+tstamp);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
         cnode=TreeView->Items->AddChild(node,"Validity    "+GetToken(6,remdesc," "));
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
         cnode=TreeView->Items->AddChild(node,"Bits        "+GetToken(9,remdesc," "));
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;

         cpkkey->clear();
      }
   }
   TreeView->Items->EndUpdate();
   RECT r = { 0,0,4096,4096 };
   InvalidateRect(TreeView->Handle,&r,false);
   delete cpkkey;
   delete next;
}
//---------------------------------------------------------------------------
//  TCpkKeyWin
//---------------------------------------------------------------------------
__fastcall TCpkKeyWin::TCpkKeyWin(TComponent* Owner)
  : TMixKeyWin(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyWin::TCpkKeyWin(TComponent* Owner, AnsiString KeyFile,
   AnsiString TypFile, AnsiString ListFile) : TMixKeyWin(Owner)
{
   curkey = -1;
   keyring = KeyFile; typfile = TypFile;
   cap = Caption; Caption = "Loading...";
   SetHelpBtnPos();
   SetNothingSelected(); SaveBtn->Enabled = RefreshBtn->Enabled = false;
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   //AppProcessMessages();
   keynode = new TList();
   keylist = new TCpkKeyList(keyring);
   dislist = new TCpkKeyList();
   typlist = new TStringList(); typlist->Sorted = true;
   if (FileExists(typfile)) typlist->LoadFromFile(typfile);
   CpkGenType1(typlist,keylist,false);
   ClearAllBtn->Enabled = keylist->Count==0 ? false : true;
   DeleteBtn->Enabled = false;
   //DisableBtn->Enabled = false;
   EnableDisableBtn(false);

   keylist->GenTreeView(TreeView,typlist,keynode);
   RequestBtn->Enabled = false;
   DisableBtn->Enabled = false;
   DeleteBtn->Enabled = false;
   SaveBtn->Enabled = false;
   checksave = true;
   modified = false;
   Caption = cap;
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyWin::~TCpkKeyWin()
{
   CpkKeyWin = NULL;
}
//---------------------------------------------------------------------------
bool __fastcall TCpkKeyWin::EnabledDesc(AnsiString &keydesc)
{
   bool enabled=false;
   AnsiString type,desc=CrtDesc(keydesc);
   for (int i=0; i<typlist->Count; i++)
   {
      type = typlist->Strings[i];
      if (type.SubString(1,1)=="#") continue;
      if (desc==type)
      {
         enabled = true;
         break;
      }
   }
   return enabled;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin::RemailerDocItemClick(TObject *Sender)
{
   TMenuItem *item = dynamic_cast<TMenuItem*>(Sender);
   if (!item) return;

   switch (item->Tag)
   {
      case 1: EditTextFile(cringtxt); break;
      case 2: EditTextFile(ctyp1txt); break;
      case 3: EditTextFile(clisttxt); break;
   }
}
//---------------------------------------------------------------------------
int __fastcall TCpkKeyWin::TimeStamp(AnsiString &keydesc)
{
   TCpkKeyList *keys=dynamic_cast<TCpkKeyList*>(keylist);
   if (keys) return keys->TimeStamp(keydesc);
   return 0;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin::AddDupsImport(TCpkKeyList *dupkeys)
{
   int dos,kos=-1,dstamp,kstamp;
   AnsiString dup,org,du2,or2,dupshrt,keydesc;
   TCpkKeyList *Keylist=(TCpkKeyList*)keylist;

   AddKeysImport(dupkeys);
   for (int i=0; i<dupkeys->Count; i++)
   {
      dup = dupkeys->FullDesc(i);
      du2 = dupkeys->CrtDesc(i);
      dupshrt = dupkeys->KeyShort(i);

      for (int i=0; i<Keylist->Count; i++)
      {
         keydesc = Keylist->Strings[i];
         if (dupshrt==Keylist->KeyShort(i) && dup!=Keylist->FullDesc(i))
         {
            kos = i;
            break;
         }
      }
      if (kos<0)
      {
         MsgBoxHwnd(Handle,"Unable to find existing "+dupshrt+" duplicate.",
            "Error Condition",MB_OK);
         continue;
      }

      org = Keylist->FullDesc(kos);
      dos = Keylist->IndexOf(du2);

      dstamp = TimeStamp(dup); kstamp = TimeStamp(org);
      if (dstamp==kstamp) continue;

      if (dstamp>kstamp)
      {
         EnableTypeFile(kos,false);
         EnableTreeView(kos,false);
         EnableTypeFile(dos,true);
         EnableTreeView(dos,true);
      }
      else if (kstamp>dstamp)
      {
         EnableTypeFile(dos,false);
         EnableTreeView(dos,false);
         EnableTypeFile(kos,true);
         EnableTreeView(kos,true);
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin::ImportBtnClick(TObject *Sender)
{
   AnsiString ImportDir,orgDir;
   TCpkKeyList *impkeys = new TCpkKeyList();
   TCpkKeyList *dupkeys = new TCpkKeyList();
   ImportDir = orgDir = GetAppIni(CpkImportDir,MixDir());
   if (ImportCyberpunkKeys(this,(TCpkKeyList*)keylist,impkeys,dupkeys,ImportDir))
   {
      if (impkeys->Count)
      {
         // Sleep(150); SetRedraw(this,0); TreeView->Items->Clear(); SetRedraw(this,1);
         //AppProcessMessages(); SetRedraw(this,0); Sleep(150); SetRedraw(this,1);
         Sleep(150);
         BringToFront();
         AppProcessMessages();
         AddKeysImport(impkeys);
      }
      if (dupkeys->Count)
      {
         BringToFront();
         AppProcessMessages();
         AddDupsImport(dupkeys);
      }
   }
   if (ImportDir!=orgDir)
      PutAppIni(MixImportDir,ImportDir);
   delete dupkeys;
   delete impkeys;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin::AddKeysImport(TCpkKeyList *newkeys)
{
   keylist->newkeys->Text = newkeys->Text;
   keylist->AddKeys(newkeys);
   CpkGenType1(typlist,keylist);
   typlistmod = true;
   //delete keys;
   keylist->GenTreeView(TreeView,typlist,keynode);
   SaveBtn->Enabled = RefreshBtn->Enabled = true;
   SetNothingSelected();
   modified = true;
   SetCount();
}
//---------------------------------------------------------------------------
/*void __fastcall TCpkKeyWin::ImportBtnClick(TObject *Sender)
{
   AnsiString ImportDir,orgDir,dupdesc,dupshrt,keydesc;
   TCpkKeyList *impkeys = new TCpkKeyList();
   TCpkKeyList *dupkeys = new TCpkKeyList();
   ImportDir = orgDir = GetAppIni(CpkImportDir,MixDir());
   if (ImportCyberpunkKeys(this,(TCpkKeyList*)keylist,impkeys,dupkeys,ImportDir))
   {
      if (impkeys->Count)
      {
         Sleep(150); SetRedraw(this,0); TreeView->Items->Clear(); SetRedraw(this,1);
         AppProcessMessages(); SetRedraw(this,0); Sleep(150); SetRedraw(this,1);
         BringToFront();
         AddKeysImport(impkeys);
      }
      if (dupkeys->Count)
      {
         for (int d=0; d<dupkeys->Count; d++)
         {
            dupdesc = dupkeys->Strings[d];
            dupshrt = GetToken(0,dupdesc," ").LowerCase();
            keylist->AddKey(dupdesc,dynamic_cast<TStrings*>(dupkeys->Objects[d]));
            for (int k=0; k<keylist->Count; k++)
            {
               keydesc = keylist->Strings[k];
               if (dupshrt==GetToken(0,keydesc," ").LowerCase())
               {
                  if (TimeStamp(dupdesc)>TimeStamp(keydesc))
                  {
                     EnableKey(dupdesc,true); EnableKey(keydesc,false);
                  }
                  else
                  {
                     EnableKey(keydesc,true); EnableKey(dupdesc,false);
                  }break;
               }
            }
         }
         GenTreeView();
      }
   }
   if (ImportDir!=orgDir)
      PutAppIni(CpkImportDir,ImportDir);
   delete dupkeys;
   delete impkeys;
}*/
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin::HelpBtnClick(TObject *Sender)
{
   OpenHelp(
      "CypherpunkKeys\nCypherpunkKeysImp\nCypherpunkKeysDup",
      "Cypherpunk Key Manager",
      "Cypherpunk Keyring Manager"
   );
}
//---------------------------------------------------------------------------



