//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <time.h>
#include <clipbrd.hpp>
#pragma hdrstop

#include "PgpKeyWins.h"
#include "PgpKeyGenDlgs.h"
#include "PgpKeyGenDoDlgs.h"
#include "PgpKeyImpDlgs.h"
#include "PgpKeyExpDlgs.h"
#include "HelpDlgs.h"
#include "mixmaster.h"
#include "cyberpunk.h"
#include "pgpfiles.h"
#include "pgpmail.h"
#include "fmxutils.h"
#include "pgpsdk.h"
#include "global.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma link "explbtn"
#pragma resource "*.dfm"
TPgpKeyWin *PgpKeyWin;
const bool dorewind=true;
const bool enable=true;
#define DEFKEYS NULL
#define PRIVATES2 true
#define COMPAT5 kPGPExportFormat_Basic
//---------------------------------------------------------------------------
AnsiString binstr(byte num)
{
   char numstr[16];
   AnsiString valstr = s(itoa(num,numstr,2));
   while (valstr.Length()<8) valstr = "0"+valstr;
   return valstr;
}
//---------------------------------------------------------------------------
// TPGPbufferList
//---------------------------------------------------------------------------
__fastcall TPGPbufferList::TPGPbufferList()
   : TStringList()
{
}
//---------------------------------------------------------------------------
__fastcall TPGPbufferList::~TPGPbufferList()
{
   for (int i=0; i<Count; i++)
      delete (TPGPbuffer*)Objects[i];
}
//---------------------------------------------------------------------------
void __fastcall TPGPbufferList::Clear()
{
   for (int i=0; i<Count; i++)
      delete (TPGPbuffer*)Objects[i];
   TStringList::Clear();
}
//---------------------------------------------------------------------------
// TPgpKeyWin
//---------------------------------------------------------------------------
__fastcall TPgpKeyWin::TPgpKeyWin(TComponent* Owner)
  : TForm(Owner)
{
   SetHelpBtnPos();
   modified = false;
   nodes = new TList();
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
__fastcall TPgpKeyWin::TPgpKeyWin(TComponent* Owner, AnsiString pubringpkr, AnsiString secringskr)
  : TForm(Owner)
{
   if (pubringpkr.IsEmpty()) pubringpkr = AppDir+"pubring.pkr";
   if (secringskr.IsEmpty()) secringskr = AppDir+"secring.skr";

   lastupdate = 0;
   pubring = pubringpkr;
   secring = secringskr;
   sdb = new TPGPbuffer(secringskr);
   pdb = new TPGPbuffer(pubringpkr);

   TStringList *nada = new TStringList();
   if (!FileExists(secringskr)) nada->SaveToFile(secringskr);
   if (!FileExists(pubringpkr)) nada->SaveToFile(pubringpkr);
   if ( FileExists(pubringpkr)) lastupdate = FileDateTime(pubringpkr);
   else lastupdate = 0;
   delete nada;

   SetHelpBtnPos();
   closing = false;
   nodes = new TList();
   enables = new TStringList();
   deletes = new TStringList();
   DeleteBtn->Enabled = SignBtn->Enabled = false;
   EnableDisableBtn(false);
   if (!HasSdk())
   {
      RefreshBtn->Enabled = false;
      SaveBtn->Enabled = false;
      SetNoSDK();
   }
   else
   {
   // setup as to not do any saving to PGP6
      SaveBtn->Enabled = false;
      SaveBtn->DropDownMenu = NULL;
      SaveBtn->Width = 29;
      SaveBtn->OnClick = SaveBtnClick;
      RefreshBtn->Left -= 8;
      for (int i=0; i<Panel1->ControlCount; i++)
      {
         TControl *control = Panel1->Controls[i];
         if (control->Left>RefreshBtn->Left) control->Left -= 8;
      }
   }
   SetHelpBtnPos();
   modified = false;
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   GenTreeView(TreeView);
}
//---------------------------------------------------------------------------
__fastcall TPgpKeyWin::~TPgpKeyWin()
{
   AppMainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)"");
   delete deletes;
   delete enables;
   delete nodes;
   delete sdb;
   delete pdb;
   PgpKeyWin = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::SetNoSDK()
{
   SaveBtn->DropDownMenu = NULL;
   SaveBtn->Width = 29;
   SaveBtn->OnClick = SaveBtnClick;
   RefreshBtn->DropDownMenu = NULL;
   RefreshBtn->Width = 29;
   RefreshBtn->OnClick = RefreshFromDiskItemClick;
   RefreshBtn->Left -= 8;
   for (int i=0; i<Panel1->ControlCount; i++)
   {
      TControl *control = Panel1->Controls[i];
      if (control->Left>RefreshBtn->Left) control->Left -= 16;
   }
   //GenKeyBtn->Visible = true;
   //Bevel4->Visible = true;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::EnableDisableBtn(bool enable)
{
   Graphics::TBitmap *bitmap=DisableBtn->Bitmap;
   TCanvas *canvas=bitmap->Canvas;
   SetRedraw(DisableBtn,0);
   if (enable)
   {
      for (int h=0; h<bitmap->Height; h++)
         for (int w=0; w<bitmap->Width; w++)
            if (canvas->Pixels[w][h]==clBlack) canvas->Pixels[w][h] = clBlue;
   }
   else
   {
      for (int h=0; h<bitmap->Height; h++)
         for (int w=0; w<bitmap->Width; w++)
            if (canvas->Pixels[w][h]==clBlue) canvas->Pixels[w][h] = clBlack;
   }
   DisableBtn->Enabled = enable;
   SetRedraw(DisableBtn,1);
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::SetHelpBtnPos()
{
   HelpBtn->Left = Width-58;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::FormResize(TObject *Sender)
{
   SetHelpBtnPos();
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::FormClose(TObject *Sender, TCloseAction &Action)
{
   Action = caFree;
}
//---------------------------------------------------------------------------
AnsiString __fastcall AlgoName(int algo)
{
   switch (algo)
   {
      case PGP_ES_RSA: return "RSA";
      case PGP_E_ELG : return "DH";
      case PGP_S_DSA : return "DSS";
   }
   return "algo name error";
}
//---------------------------------------------------------------------------
AnsiString TimeStamp(long unixtime)
{
   AnsiString text = ctime(&unixtime);
   return text.SubString(1,text.Length()-1);
}
//---------------------------------------------------------------------------
AnsiString __fastcall padright(AnsiString string, int width)
{
   AnsiString str;
   return string+str.StringOfChar(32,width-string.Length());
}
//---------------------------------------------------------------------------
void __fastcall SetTreePGPItemBold(TTreeNode *ANode, bool Value, TTreeView *ATree)
{
   TTVItem item;
   int Template;
   if (!ANode) return;

   Template = Value ? -1 : 0;
   item.mask = TVIF_STATE;
   item.hItem = (HTREEITEM)ANode->ItemId;
   item.stateMask = TVIS_BOLD;
   item.state = item.stateMask & Template;
   TreeView_SetItem(ATree->Handle,&(TV_ITEM)item);
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::GenTreeView(TTreeView *TreeView, TStrings *newkeyids)
{
   byte CTB;
   Timer1->Enabled = false;
   // get a list of secret key ids for checking
   TStringList *secrets = new TStringList();
   TPGPbuffer *sec,*key = new TPGPbuffer();
   sdb->rewind();
   while (key->copykeyfrom(sdb))
   {
      if (SecretKeyPacket(key->CTB)) secrets->AddObject(key->idtext8,new TPGPbuffer(key));
      key->clear();
   }
//view(secrets);
   TStringList *nodelist = new TStringList(); nodelist->Sorted = true;
   TStringList *userids = new TStringList();
   AnsiString keyid,name,index,spacebuf;
   int keyver,keytime,keyalgo,keybits;//,keyval;
   int subkeyalgo,subkeybits,l;
   int pktlen,uidmax=0;
   bool enabled,revoked,expired;
   char buffer[256];

   TPGPbuffer *pkt = new TPGPbuffer();

   key->clear();
   pdb->rewind();
   while (key->copykeyfrom(pdb))
   {
      index = key->firstuid;
      l = index.Length(); if (l>uidmax) uidmax = l;
      nodelist->AddObject(index,new TPGPbuffer(key));
      key->clear();
   }

   nodes->Clear();
   TreeView->Items->BeginUpdate();
   TreeView->Items->Clear();
   AnsiString revokeflag="<---REVOKED",expireflag="<---EXPIRED";
   for (int i=0; i<nodelist->Count; i++)
   {
      key = dynamic_cast<TPGPbuffer*>(nodelist->Objects[i]);
      userids->Clear();
      subkeyalgo=0; subkeybits=0;
      revoked = key->revoked;
      enabled = key->enabled;
      expired = key->expired;
      key->rewind();
      while (pkt->copypacketfrom(key))
      {
         pktlen = pkt->GetPacketInfo(&CTB);
         if (PublicSubKeyPacket(CTB))
         {
            keyver = pkt->ReadByte();        // key version
            pkt->ReadLong();                 // time stamp
            if (keyver<4) pkt->ReadInt();    // validity
            subkeyalgo = pkt->ReadByte();    // algo
            subkeybits = pkt->ReadInt();     // key bits
         }
         else
         if (PublicKeyPacket(CTB))
         {
            //keyval = 0;
            keyver = pkt->ReadByte();
            keytime = pkt->ReadLong();
            //if (keyver<4) keyval =
            if (keyver<4) pkt->ReadInt();
            keyalgo = pkt->ReadByte();
            keybits = pkt->ReadInt();
            keyid = pkt->idtext8;
         }
         else
         if (UserIdPacket(CTB))
         {
            pkt->Read(buffer,pktlen); buffer[pktlen]=0L;
            userids->Add(s(buffer));
         }
         pkt->Clear();
      }

      TTreeNode *node,*cnode,*unode;
      AnsiString tmp,name,thebits,thealgo;
      // check for expired keys
      AnsiString expires="never";
      if (expired) expires += "  "+expireflag;
      name = padright(nodelist->Strings[i],uidmax+2)+"0x"+key->idtext8+"  ";
      // start generating treeview
      node=TreeView->Items->AddChildObject(TreeView->Selected,name,key);
      if (newkeyids && newkeyids->IndexOf(key->idtext8)>=0)
          SetTreePGPItemBold(node,true,TreeView);
      nodes->Add(node);
      int idx = secrets->IndexOf(keyid);
      if (idx>=0)
      {
         sec = (TPGPbuffer*)secrets->Objects[idx];
         sec->rewind();
         key->CopyFrom(sec,sec->length);
      }
      node->ImageIndex = idx>=0 ? 0 : 1;
      if (!enabled) node->ImageIndex += 2;
      node->SelectedIndex = node->ImageIndex;
      AnsiString keyidline = keyid;
      if (revoked) keyidline += "  "+revokeflag;
      cnode=TreeView->Items->AddChild(node,"Key Id       0x"+keyidline);
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      if (userids->Count)
      cnode=TreeView->Items->AddChild(node,"User Ids     "+userids->Strings[0]);
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      for (int x=0; x<userids->Count; x++)
      {
         unode=TreeView->Items->AddChild(cnode,userids->Strings[x]);
         unode->ImageIndex = -1; unode->SelectedIndex = -1;
      }
      cnode=TreeView->Items->AddChild(node,"Key Version  "+s(keyver));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"TimeStamp    "+TimeStamp(keytime));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Disabled     "+s(enabled ? "no":"yes"));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      AnsiString expiresline = expires;
      if (expired) expiresline += "  "+expireflag;
      cnode=TreeView->Items->AddChild(node,"Expires      "+expiresline);
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      thealgo = AlgoName(keyalgo);
      if (subkeyalgo) thealgo = AlgoName(subkeyalgo)+"/"+thealgo;
      cnode=TreeView->Items->AddChild(node,"Algorithm    "+thealgo);
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      thebits = s(keybits);
      if (subkeybits) thebits = s(subkeybits)+"/"+keybits;
      cnode=TreeView->Items->AddChild(node,"Bits         "+thebits);
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      // finish the display line
      AnsiString display = node->Text+" ";
      display += padright(thealgo,6)+"  "+padright(thebits,9)+" ";
      if (revoked) display += revokeflag; else
      if (expired) display += expireflag;
      node->Text = display.TrimRight();
      //key->clear();  << do NOT clear key
   }

   TreeView->Items->EndUpdate();
   EnableDisableBtn(false);
   DeleteBtn->Enabled = SignBtn->Enabled = false;
   ExportBtn->Enabled = false;
   curkey = -1;

   delete pkt;
   delete nodelist;
   delete userids;
   for (int i=0; i<secrets->Count; i++)
      delete dynamic_cast<TPGPbuffer*>(secrets->Objects[i]);
   delete secrets;
   ExportBtn->Enabled = TreeView->Items->Count;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::ClearTreeView()
{
   TreeView->Items->BeginUpdate();
   TreeView->Items->Clear();
   TreeView->Items->EndUpdate();
   Application->ProcessMessages();
}
//---------------------------------------------------------------------------
bool __fastcall TPgpKeyWin::DeleteKey(int atPos)
{
   if (atPos<0 || atPos>=nodes->Count) return false;
   TTreeNode *node = (TTreeNode*)nodes->Items[atPos];
   TPGPbuffer *key = (TPGPbuffer*)node->Data;
   if (!deletes->IndexOf(key->idtext8)>=0)
      deletes->Add(key->idtext8);
   nodes->Delete(atPos);
   delete node->Data;
   node->Delete();
   SaveBtn->Enabled = true;
   if (!HasSdk())
   {
      RefreshBtn->Enabled = true;
      SaveBtn->Enabled = true;
   }
   if (!TreeView->Items->Count) ExportBtn->Enabled = false;
   modified = true;
   return true;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::DeleteBtnClick(TObject *Sender)
{
   if (MsgBoxHwnd(Handle,"Delete the currently selected key?","Confirm",MB_OKCANCEL)==IDOK &&
       MsgBoxHwnd(Handle,"Deleted key will be lost forever. Are you sure?","Confirm Again",MB_OKCANCEL)==IDOK)
   {
      DeleteKey(curkey);
      if (!nodes->Count)
      {
         EnableDisableBtn(false);
         DeleteBtn->Enabled = SignBtn->Enabled = false;
       //ExportBtn->Enabled = false;
      }
      SaveBtn->Enabled = true;
      if (!HasSdk())
      {
         RefreshBtn->Enabled = true;
         SaveBtn->Enabled = true;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::SetCount(bool clear)
{
   AnsiString cur,count;
   if (Application->Terminated) return;
   if (WindowState!=wsMinimized && !clear && nodes->Count)
   {
      cur = curkey>=0 ? s(curkey+1)+"/" : s("");
      count = cur+s(nodes->Count);
   }
   AppMainForm->Perform(WM_SHOWSTATUS,1,(LPARAM)count.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::SetNothingSelected()
{
   EnableDisableBtn(false);
   DeleteBtn->Enabled = SignBtn->Enabled = false;
 //ExportBtn->Enabled = false;
   curkey = -1;
   SetCount();
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::TreeViewChange(TObject *Sender, TTreeNode *Node)
{
   //TPGPbuffer *key = (TPGPbuffer*)Node->Data;
   EnableDisableBtn(Node->Level==0 && !((TPGPbuffer*)Node->Data)->ispair);
   //DeleteBtn->Enabled = ExportBtn->Enabled = Node->Level==0;
   DeleteBtn->Enabled = SignBtn->Enabled = Node->Level==0;
   curkey = Node->Index;
   SetCount();
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (modified)
   {
      switch (MsgBoxHwnd(Handle,
        "Your keyrings are modified. Save your changes?","Confirm",
         MB_YESNOCANCEL))
      {
         case IDCANCEL: CanClose = false; break;
         case IDYES: closing = true;
            SaveBtn->Click();
      }
   }
   //if (deletes->Count) deletes->SaveToFile(deletespgp);
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::OkBtnClick(TObject *Sender)
{
   closing = true;
   if (modified) SaveBtn->Click();
   Close();
}
//---------------------------------------------------------------------------
AnsiString hexstr(byte num)
{
   char numstr[16];
   AnsiString valstr = s(itoa(num,numstr,2));
   while (valstr.Length()<8) valstr = "0"+valstr;
   return valstr;
}
//---------------------------------------------------------------------------
bool __fastcall TPgpKeyWin::EnableKey(int atPos, bool Enable)
{
   if (atPos<0 || atPos>=nodes->Count) return false;
   bool ok;
   TTreeNode *node = (TTreeNode*)nodes->Items[atPos];
   TPGPbuffer* key = (TPGPbuffer*)node->Data;
   enables->Values[key->idtext8]= enable ? "1" : "0";
   if ((ok=key->enable(Enable))==true)
   {
      SaveBtn->Enabled = true;
      if (!HasSdk())
      {
         RefreshBtn->Enabled = true;
         SaveBtn->Enabled = true;
      }
      modified = true;
   }
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TPgpKeyWin::EnabledKey(int atPos)
{
   if (atPos<0 || atPos>=nodes->Count) return false;
   TTreeNode *node = (TTreeNode*)nodes->Items[atPos];
   TPGPbuffer* key = (TPGPbuffer*)node->Data;
   return key->enabled;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::DisableBtnClick(TObject *Sender)
{
   TTreeNode *node = (TTreeNode*)nodes->Items[curkey];
   TPGPbuffer *key = (TPGPbuffer*)node->Data;
   bool enabled = !key->enabled;
   EnableKey(curkey,enabled);

   bool ispair = node->ImageIndex==0 || node->ImageIndex==2;
   //if ( ispair &&  enabled) node->ImageIndex = 0; else
   //if ( ispair && !enabled) node->ImageIndex = 2; else
   if (!ispair &&  enabled) node->ImageIndex = 1; else
   if (!ispair && !enabled) node->ImageIndex = 3;
   node->SelectedIndex = node->ImageIndex;

   RECT r = { 0,0,50,2000 };
   InvalidateRect(TreeView->Handle,&r,false);
   SaveBtn->Enabled = true;
   if (!HasSdk())
   {
      RefreshBtn->Enabled = true;
      SaveBtn->Enabled = true;
   }
   modified = true;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::TreeViewMouseDown(TObject *Sender,
  TMouseButton Button, TShiftState Shift, int X, int Y)
{
   THitTests HitTest = TreeView->GetHitTestInfoAt(X, Y);
   if (HitTest.Contains(htOnIcon) && TreeView->Selected && !((TPGPbuffer*)TreeView->Selected->Data)->ispair)
   {
      DisableBtnClick(Sender);
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::SaveToPGP6ItemClick(TObject *Sender)
{
   // unused until save works properly
   //CheckSaveToPGP6();
}
//---------------------------------------------------------------------------
/*bool __fastcall TPgpKeyWin::CheckSaveToPGP6()
{
// unused posibly flawed
   if (MsgBoxHwnd(Handle,
      "\n  Update your PGP6 keyrings with your QuickSilver keys?  \n ",
      "Confirm",MB_OKCANCEL)==IDOK)
   {
      if (modified) SaveBtn->Click();
      SaveToPGP6();
      return true;
   }
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall TPgpKeyWin::SaveToPGP6()
{
   if (deletes->Count && !PGPqdkDeleteKeys(Handle,NULL,deletes->Text.c_str()))
      return false;
   TStringList *pub = new TStringList();
   TStringList *sec = new TStringList();
   enables->Clear(); deletes->Clear();
   pdb->GetAscii(pub);
   sdb->GetAscii(sec);
   pub->AddStrings(sec);
   bool ok=PGPqdkImportKeys(Handle,DEFKEYS,pub->Text.c_str());
   if (ok)
   {
      ClearTreeView(); Sleep(100);
      GenTreeView(TreeView);
   }
   delete sec;
   delete pub;
   return ok;
}
bool __fastcall TPgpKeyWin::SaveToPGP6()
{
   // not used, flawed procedure
   if (deletes->Count || enables->Count)
   {
      if (!PGPqdkDeleteKeys(Handle,NULL,deletes->Text.c_str())) return false;
      if (!PGPqdkEnableKeys(Handle,NULL,enables->Text.c_str())) return false;
      enables->Clear(); deletes->Clear();
      //PGPqdkUpdateQSKeyrings(AppMainForm,NULL);
      //ClearTreeView();
      //Sleep(50);
      //Refresh();
      modified = false;
      return true;
   }
   return false;
}*/
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::SaveBtnClick(TObject *Sender)
{
   cap = Caption;
   Caption = "Saving keyrings to disk...";
   AppMainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)"Saving keyrings to disk...");
   SetRedraw(this,0);
   AppProcessMessages(); Sleep(100);
   if (!Save())
   {
      AppMainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)"");
      SetRedraw(this,1);
      Caption = cap;
      return;
   }
   if (!HasSdk())
   {
      RefreshBtn->Enabled = false;
      SaveBtn->Enabled = false;
   }
   //ClearTreeView(); Sleep(100);
   GenTreeView(TreeView);
   AppProcessMessages(); Sleep(100);
   SaveBtn->Enabled = false;
   SetRedraw(this,1);
   Caption = cap;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::SaveToDiskItemClick(TObject *Sender)
{
   SaveBtn->Click();
}
//---------------------------------------------------------------------------
bool __fastcall TPgpKeyWin::Save()
{
   // use routines for openpgp only
   pdb->clear();
   sdb->clear();
   TPGPbuffer *key = new TPGPbuffer();
   for (int i=0; i<nodes->Count; i++)
   {
      TTreeNode *node = (TTreeNode*)nodes->Items[i];
      TPGPbuffer *keys = (TPGPbuffer*)node->Data;
      keys->rewind();
      while (key->copykeyfrom(keys,dorewind))
      {
         if (SecretKeyPacket(key->CTB)) sdb->copyfrom(key,key->length); else
         if (PublicKeyPacket(key->CTB)) pdb->copyfrom(key,key->length);
         key->clear();
      }
   }
   delete key;
   sdb->save();
   pdb->save();
   modified = false;
   return true;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::RefreshFromDiskItemClick(TObject *Sender)
{
   if (modified && MsgBoxHwnd(Handle,
      s("\n  Your keyrings are modified. Refreshing will overwrite changes.  \n\n")+
      s("  Refresh anyway?\n"),
      s("Confirm"),
      MB_OKCANCEL)==IDCANCEL)
         return;

   ClearTreeView(); Sleep(100);
   Refresh();
}
//---------------------------------------------------------------------------
bool __fastcall TPgpKeyWin::Refresh()
{
   if (closing) return false;
   cap = Caption; Caption = "Refreshing key manager from disk";
   AppMainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)"Refreshing key manager from disk");
   AppProcessMessages(); Sleep(100);

   delete pdb; pdb = new TPGPbuffer(pubring);
   delete sdb; sdb = new TPGPbuffer(secring);
   GenTreeView(TreeView);
   SaveBtn->Enabled = false;
   if (!HasSdk())
   {
      RefreshBtn->Enabled = false;
      SaveBtn->Enabled = false;
   }
   modified = false;
   deletes->Clear();
   enables->Clear();

   Sleep(200);
   AppMainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)"");
   Caption = cap;
   lastupdate = FileDateTime(PgpPublicRing());
   return true;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::RefreshFromPGP6ItemClick(TObject *Sender)
{
   CheckRefreshFromPGP6();
}
//---------------------------------------------------------------------------
bool __fastcall TPgpKeyWin::CheckRefreshFromPGP6()
{
   AppMainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)"");
   /*if (modified)
   {
      if (MsgBoxHwnd(Handle,
         s(" Your keyrings are modified. Refreshing from \n")+
         s(" PGP6 may overwrite changes.\n\n")+
         s(" Refresh anyway? \n"),
         s("Confirm"),
         MB_OKCANCEL)==IDCANCEL)
            return false;
   }
   else*/
   {
      if (MsgBoxHwnd(Handle,
         s(" Refresh your keyrings from PGP6? "),
         s("Confirm"),
         MB_OKCANCEL)==IDCANCEL)
            return false;
   }
   ClearTreeView(); Sleep(100);
   RefreshFromPGP6();
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TPgpKeyWin::RefreshFromPGP6()
{
   if (closing) return false;
   cap = Caption; Caption = "Refreshing keyrings from PGP6";
   AppMainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)"Refreshing keyrings from PGP6");

   if (PGPqdkUpdateQSKeyrings(this,NULL))
   {
      SetNothingSelected();
      AppProcessMessages(); //Sleep(100);
      SetRedraw(this,0);
      Caption = cap;
      AppProcessMessages(); Sleep(100);
      ClearTreeView();
      Refresh();
      GenTreeView(TreeView,NULL);
      AppProcessMessages();
      SetRedraw(this,1);
   }
   AppProcessMessages();
   AppMainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)"");
   Caption = cap;
   return true;
}
//---------------------------------------------------------------------------
/*bool __fastcall TPgpKeyWin::RefreshFromPGP6()
{
   if (closing) return false;
   AppMainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)"Refreshing key manager from PGP6");

   TPGPbuffer *s = new TPGPbuffer();
   TPGPbuffer *p = new TPGPbuffer();
   TPGPbuffer *key = new TPGPbuffer();

   TStringList *imports = new TStringList();
   imports->SetText(PGPqdkExportKeys(Handle,DEFKEYS,DEFKEYS,COMPAT5,PRIVATES2));
   TPGPbuffer *newkeys = new TPGPbuffer(imports);
   newkeys->rewind();
   while (key->CopyKeyFrom(newkeys,REWIND))
   {
      key->Enable(true);
      if (PublicKeyPacket(key->CTB)) p->copyfrom(key); else
      if (SecretKeyPacket(key->CTB)) s->copyfrom(key);
      key->clear();
   }
   pdb->clear(); sdb->Clear();
   p->rewind(); s->rewind();
   pdb->copyfrom(p);
   sdb->copyfrom(s);

   GenTreeView(TreeView,NULL);
   RefreshBtn->Enabled = true;
   SaveBtn->Enabled = true;

   modified = true;
   deletes->Clear();
   enables->Clear();
   delete key;
   delete p;
   delete s;

   AppMainForm->Perform(WM_SHOWSTATUS,0,
      (LPARAM)"Key manager refreshed from PGP6. Changes not saved to disk.");
   return true;
}
*/
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::ImportBtnClick(TObject *Sender)
{
   AnsiString orgdir,importdir;
   TPGPbuffer *impkeys = new TPGPbuffer();
   importdir = orgdir = GetAppIni(PgpImportDir,AppDir);
   if (ImportPGPKeys(this,impkeys,importdir))
   {
//sm((int)impkeys->count);
      if (impkeys->count)
      {
         BringToFront();
         AppProcessMessages();
         Sleep(100);
         AddKeysImport(impkeys);
      }
   }
   if (importdir!=orgdir)
      PutAppIni(PgpImportDir,importdir);
   delete impkeys;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::PopupMenuPopup(TObject *Sender)
{
   if (TreeView->Selected && TreeView->Selected->Level==0 && curkey>=0 &&
     !((TPGPbuffer*)TreeView->Selected->Data)->ispair)
   {
      PopDisableItem->Enabled = true;
      PopDisableItem->Caption = EnabledKey(curkey) ? "Disable this &key":"Enable this &key"; //keylist->EnabledDesc(KeyDesc(curkey),typlist);
   }
   else PopDisableItem->Enabled = false;

   PopSaveItem->Enabled = modified;
   PopRefreshItem->Enabled = modified;
   PopImportItem->Enabled = true;
   PopDeleteItem->Enabled = curkey>=0;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::WMSaveBtnClicked(TMessage& Msg)
{
   SaveBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::WMRefreshBtnClicked(TMessage& Msg)
{
   //Timer2->Enabled = true;
   RefreshAfterPGP6();
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::WMImportBtnClicked(TMessage& Msg)
{
   ImportBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::WMDisableBtnClicked(TMessage& Msg)
{
   DisableBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::WMDeleteBtnClicked(TMessage& Msg)
{
   DeleteBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::WMAreYouKeyWindow(TMessage& Msg)
{
   Msg.Result = 1;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::WMAreYouPgpKeyWindow(TMessage& Msg)
{
   Msg.Result = 1;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::WMDoPGP6Update(TMessage& Msg)
{
   PGPqdkUpdateQSKeyrings(AppMainForm,NULL); // not working, undefined func
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::WMGetKeyringMenuDat(TMessage& Msg)
{
  KeyringMenuDat *menudat = (KeyringMenuDat*)Msg.LParam;
  bool hassel = curkey>=0;
  menudat->Modified = modified;
  menudat->HasSel = hassel;
  menudat->RefreshEnabled = RefreshFromDiskItem->Enabled; //
  menudat->CurEnabled = EnabledKey(curkey);
  menudat->IsPair = hassel && ((TPGPbuffer*)TreeView->Selected->Data)->ispair;
  Msg.Result = 1;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::WMKeyringNewKeyItemClicked(TMessage& Msg)
{
   GenKeyBtn->Click();
}
//---------------------------------------------------------------------------
/*bool __fastcall TPgpKeyWin::AddKeysImportToPGP6(TPGPbuffer *newkeys)
{
   TStringList *asckeys = new TStringList();
   newkeys->export(asckeys);
   bool ok=PGPqdkImportKeys(Handle,NULL,asckeys->Text.c_str());
   delete asckeys;
   return ok;
}*/
//---------------------------------------------------------------------------
bool __fastcall TPgpKeyWin::AddKeysImport(TPGPbuffer *newkeys)
{
   if (newkeys->count==0) false;

   pdb->rewind(); sdb->rewind();
   TPGPbuffer *sd = new TPGPbuffer();
   TPGPbuffer *pd = new TPGPbuffer();
   TPGPbuffer *key = new TPGPbuffer();
   TStringList *newkeyids = new TStringList();

   while (key->copykeyfrom(newkeys,REWIND)) // get all new key idsto list
   {
      newkeyids->Add(key->idtext8);
      key->clear();
   }
   pdb->rewind();
   while (key->copykeyfrom(pdb,REWIND))
   {
      if (newkeyids->IndexOf(key->idtext8)<0) pd->copyfrom(key);
      key->clear();
   }
   sdb->rewind();
   while (key->copykeyfrom(sdb,REWIND))
   {
      if (newkeyids->IndexOf(key->idtext8)<0) sd->copyfrom(key);
      key->clear();
   }
   newkeys->rewind();
   while (key->copykeyfrom(newkeys,REWIND))
   {
      key->enable(true);
      if (PublicKeyPacket(key->CTB)) pd->copyfrom(key); else
      if (SecretKeyPacket(key->CTB)) sd->copyfrom(key);
      key->clear();
   }
//sm(s((int)pd->length)+"  "+s((int)sd->length));


   pdb->clear(); sdb->Clear();
   pd->rewind(); sd->rewind();
   pdb->copyfrom(pd);
   sdb->copyfrom(sd);

//sm(s((int)pdb->length)+"  "+s((int)sdb->length));

   GenTreeView(TreeView,newkeyids);
   SaveBtn->Enabled = true;
   if (!HasSdk())
   {
      RefreshBtn->Enabled = true;
      SaveBtn->Enabled = true;
   }
   modified = true;
   delete newkeyids;
   delete key;
   delete pd;
   delete sd;
   return true;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::HelpBtnClick(TObject *Sender)
{
   OpenHelp(
      "PersonalPGPKeys\nPersonalPGPKeysImp",
      "Personal PGP Key Manager",
      "Personal PGP Keyring Manager"
   );
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::PopupMenu1Popup(TObject *Sender)
{
   RefreshFromPGP6Item->Visible = HasSdk() ? true : false;
   RefreshFromDiskItem->Enabled = modified;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::PopupMenu2Popup(TObject *Sender)
{
   SaveToPGP6Item->Visible = HasSdk() ? true : false;
   SaveToDiskItem->Enabled = modified;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::ExportBtnClick(TObject *Sender)
{
   AnsiString selkeyid,ExportDir,orgDir;
   if (curkey>=0 && curkey<nodes->Count)
   {
      TTreeNode *node = (TTreeNode*)nodes->Items[curkey];
      TPGPbuffer *key = (TPGPbuffer*)node->Data;
      if (key) selkeyid = key->idtext8;
   }
   ExportDir = orgDir = GetAppIni(PgpExportDir,MixDir());
   if (ExportOpenPGPKeys(AppMainForm, pdb, sdb, selkeyid, ExportDir))
   if (ExportDir!=orgDir)
      PutAppIni(PgpExportDir,ExportDir);
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::GenKeyBtnClick(TObject *Sender)
{
   MsgBoxHwnd(Handle,
      s("OpenPGP Key Generator\n\n")+
      s("Sorry, construction on this function will be\n")+
      s("complete next update."),
      s("Information"),
      MB_OK
   );
   //DoGenerateRSAKey(AppMainForm);
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::SignBtnClick(TObject *Sender)
{
   MsgBoxHwnd(Handle,
      s("OpenPGP Key Signing Tool\n\n")+
      s("Sorry, construction on this function will be\n")+
      s("complete next update."),
      s("Information"),
      MB_OK
   );
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::RefreshBtnClick(TObject *Sender)
{
//
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::RefreshAfterPGP6()
{
   if (modified && MsgBoxHwnd(Handle,
      s("Your regular PGP program has updated your QS PGP keyrings on disk. Your\n")+
      s("current in-memory QS PGP keyrings are also modified. Refreshing will overwrite\n")+
      s("these changes.\n\n")+
      s("Do you want to refresh your in-memory keyrings from disk?"),
      s("Confirm"),
      MB_OKCANCEL)==IDCANCEL)
         return;

   ClearTreeView();
   Refresh();
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::PopDescriptionItemClick(TObject *Sender)
{
   TTreeNode *node = curkey>0 ? (TTreeNode*)nodes->Items[curkey]:NULL;
   if (node) Clipboard()->AsText = node->Text;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::PopUserIdItemClick(TObject *Sender)
{
   TTreeNode *node = curkey>0 ? (TTreeNode*)nodes->Items[curkey]:NULL;
   if (node)
   {
      AnsiString text = node->Text; int pos = text.Pos("0x");
      if (pos>0) Clipboard()->AsText = text.SubString(1,pos-1).TrimRight();
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyWin::PopKeyIdItemClick(TObject *Sender)
{
   TTreeNode *node = curkey>0 ? (TTreeNode*)nodes->Items[curkey]:NULL;
   if (node)
   {
      AnsiString text = node->Text; int pos = text.Pos("0x");
      if (pos>0) Clipboard()->AsText = text.SubString(pos,10);
   }
}
//---------------------------------------------------------------------------
